const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const client_orders = sequelize.define(
    'client_orders',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      status: {
        type: DataTypes.TEXT,
      },

      order_name: {
        type: DataTypes.TEXT,
      },

      order_number: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  client_orders.associate = (db) => {
    db.client_orders.belongsToMany(db.client_dam, {
      as: 'assets',
      foreignKey: {
        name: 'client_orders_assetsId',
      },
      constraints: false,
      through: 'client_ordersAssetsClient_dam',
    });

    db.client_orders.belongsToMany(db.client_dam, {
      as: 'assets_filter',
      foreignKey: {
        name: 'client_orders_assetsId',
      },
      constraints: false,
      through: 'client_ordersAssetsClient_dam',
    });

    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.client_orders.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.client_orders.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return client_orders;
};
